#ifndef STARSIDASegment_h
#define STARSIDASegment_h

class STARS_IDA_Segment_t : public STARS_Segment_t
{
	public:
		STARS_IDA_Segment_t(segment_t* seg) : the_seg(seg) {}

                virtual STARS_ea_t get_startEA() { return the_seg->startEA; } 
                virtual STARS_ea_t get_endEA() { return the_seg->endEA; } 
                virtual bool IsCodeSegment()  { return the_seg->type==SEG_CODE; } 
                virtual bool IsXternSegment() { return the_seg->type==SEG_XTRN; } 
                virtual bool IsDataSegment() { return the_seg->type==SEG_DATA; } 
                virtual bool IsCommonSegment() { return the_seg->type==SEG_COMM; } 
                virtual bool IsBSSSegment() { return the_seg->type==SEG_BSS; } 
                virtual bool IsReadableSegment() { return the_seg->perm & SEGPERM_READ; }
                virtual bool IsWriteableSegment() { return the_seg->perm & SEGPERM_WRITE; }
		virtual ssize_t GetSegmentName(char* name, int len) { return ::get_segm_name(the_seg,name,len); }

	private:
		segment_t* the_seg;
		
};

#endif
